package com.hzya.frame.plugin.lets.dingtalk.push.serivce.impl;

import cn.hutool.core.lang.Assert;
import com.hzya.frame.plugin.lets.dingtalk.push.serivce.PushU8CService;
import com.hzya.frame.plugin.lets.dingtalk.vo.DjzbVO;
import org.springframework.stereotype.Service;

import java.io.File;
import java.util.ArrayList;
import java.util.Base64;
import java.util.List;

/**
 * u8c单据推送钉钉表单
 * fileBase64s为文件转了base64之后
 */
@Service("PushU8CService")
public class PushU8CServiceImpl implements PushU8CService {

    /** 委外采购（付款单）->采购付款申请(新) */
    @Override
    public String outSource(DjzbVO djzbVO, List<String> fileBase64s) {
        checkParameter(djzbVO,fileBase64s);
        return null;
    }

    /** 代理采购（付款单）->采购付款申请(店群专用) */
    @Override
    public String agency(DjzbVO djzbVO, List<String> fileBase64s) {
        checkParameter(djzbVO,fileBase64s);
        return null;
    }

    /** 调拨单内部交易（付款单）->特殊业务处理(新) */
    @Override
    public String transfer(DjzbVO djzbVO, List<String> fileBase64s) {
        checkParameter(djzbVO,fileBase64s);
        return null;
    }

    /**
     * 检查参数，VO不能为空，文件不能空
     * @param djzbVO
     * @param fileBase64s
     */
    public void checkParameter(DjzbVO djzbVO, List<String> fileBase64s){
        Assert.notNull(djzbVO,"u8c单据推送钉钉表单,检查参数，VO不能为空");
        if (fileBase64s.size() == 0) {
            Assert.state(false,"u8c单据推送钉钉表单,检查参数，文件不能空");
        }
    }

    /**
     * 文件转换
     * 将base64转为文件上传钉盘，并返回钉钉的 List<FileModuleVO>
     * @return
     */
    public List<File> baseTransformFile(List<String> fileBase64s){
        List<File> fileList=new ArrayList<>();
        for (String fileBase64 : fileBase64s) {
            // 解码Base64字符串
            byte[] decodedBytes = Base64.getDecoder().decode(fileBase64);
        }
        return fileList;
    }
}
