package com.hzya.frame.plugin.lets.util;

import com.hzya.frame.WebappApplication;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.DetailsDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.HeaderDetailsDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.HeaderDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.SaleOrderMessageDto;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.List;

import static org.junit.Assert.*;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame.plugin.lets.util
 * @Project：kangarooDataCenterV3
 * @name：OfsOrderSaleAmountAllocationUtilTest
 * @Date：2024/9/25 18:31
 * @Filename：OfsOrderSaleAmountAllocationUtilTest
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = WebappApplication.class)
public class OfsOrderSaleAmountAllocationUtilTest {

    Logger logger = LoggerFactory.getLogger(OfsOrderSaleAmountAllocationUtil.class);

    @Autowired
    private OfsOrderSaleAmountAllocationUtil ofsOrderSaleAmountAllocationUtil;

    @Autowired
    private AfterSalesOrderUtil afterSalesOrderUtil;

    @Test
    public void tocSalesAmountAllocation() {
        try {
            SaleOrderMessageDto ofsOrder = afterSalesOrderUtil.getOfsOrder("LETS-SO2024092500000020");
            List<HeaderDetailsDto> data = ofsOrder.getData();
            if (data.size() > 0) {
                //测试一：所有优惠金额都为0
                //测试二：所有优惠金额都有null
//                data.get(0).getHeader().setPlatformDiscounts(null);
//                data.get(0).getHeader().setMerchantDiscounts(null);
//                data.get(0).getHeader().setExpertDiscounts(null);
//                data.get(0).getHeader().setPayDiscounts(null);
                //测试三：全部存在优惠金额数值
//                data.get(0).getHeader().setPlatformDiscounts("2.3");
//                data.get(0).getHeader().setMerchantDiscounts("4.9");
//                data.get(0).getHeader().setExpertDiscounts("1.2");
//                data.get(0).getHeader().setPayDiscounts("6.7");
                //测试四：没有商品金额的行过滤
//                data.get(0).getDetails().get(0).setItemTotalAmount(null);
//
//                data.get(0).getHeader().setPlatformDiscounts("2.3");
//                data.get(0).getHeader().setMerchantDiscounts("4.9");
//                data.get(0).getHeader().setExpertDiscounts("1.2");
//                data.get(0).getHeader().setPayDiscounts("6.7");
//                ofsOrderSaleAmountAllocationUtil.tocSalesAmountAllocation(data.get(0));

                //测试五：部分金额不存在的过滤
//                data.get(0).getHeader().setPlatformDiscounts("2.3");
//                data.get(0).getHeader().setMerchantDiscounts("4.9");
//                data.get(0).getHeader().setExpertDiscounts(null);
//                data.get(0).getHeader().setPayDiscounts(null);
//                ofsOrderSaleAmountAllocationUtil.tocSalesAmountAllocation(data.get(0));

                //测试六：优惠金额全部都为0
//                ofsOrderSaleAmountAllocationUtil.tocSalesAmountAllocation(data.get(0));

//                ofsOrderSaleAmountAllocationUtil.printAmountOfMoneyNum(data);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


}