package com.hzya.frame.ttxofs.dto.stock;

import com.hzya.frame.ttxofs.basics.ReturnMessageBasics;
import com.hzya.frame.ttxofs.dto.returngoodordersearch.RerturnGoodsOrderSearchData;
import lombok.Data;

import java.util.List;

/**
 * OFS入库单查询相应类
 */
@Data
public class StockinOrderSearchResponse extends ReturnMessageBasics {
    public List<StockinOrder> data;

    @Data
    public static class StockinOrder {
        private StockinH header;
        private List<StockinB> details;

        @Data
        public static class StockinH {
            private String id;
            private String clientCode;
            private String companyCode;
            private String facilityCode;
            private String code;
            private String internalInstructionType;
            private String bizChannel;
            private String refOrderId;
            private String refOrderCode;
            private String refOrderType;
            private String closed;
            private String closedBy;
            private String status;
            private String allowOverReceive;
            private String totalLines;
            private String totalQty;
            private String totalAmount;
            private String totalWeight;
            private String totalVolume;
            private String totalVolumeWeight;
            private String totalFulfillAmount;
            private String totalFulfillWeight;
            private String totalFulfillVolume;
            private String totalFulfillVolumeWeight;
            private String totalFulfillQty;
            private String totalCases;
            private String totalContainers;
            private String closeAtQty;
            private String quantityUM;
            private String weightUM;
            private String volumeUM;
            private String checkInFrom;
            private String checkInTo;
            private String closedAt;
            private String note;
            private String sourceOrderCode;
            private String created;
            private String createdBy;
            private String lastUpdated;
            private String lastUpdatedBy;
            private String sourcePlatformCode;
            private String storeCode;
            private String shipFromCode;
            private String shipFromAddressCode;
            private String shipAt;
            private String tradeSuccessAt;
            private String refundedAt;//OFS退款完成时间
            private String refundStatus;//OFS退款完成状态
            private RerturnGoodsOrderSearchData rerturnGoodsOrderSearchData;//OFS售后订单
            private com.hzya.frame.ttxofs.dto.ofssalesordersearch.HeaderDetailsDto headerDetailsDto;//OFS销售订单
        }

        @Data
        public static class StockinB {
            private String id;
            private String receiptId;
            private String receiptCode;
            private String refOrderId;
            private String refOrderDetailId;
            private String clientCode;
            private String companyCode;
            private String facilityCode;
            private String skuCode;
            private String skuName;
            private String requestQty;
            private String receivedQty;
            private String openQty;
            private String quantityUM;
            private String totalWeight;
            private String totalVolume;
            private String totalVolumeWeight;
            private String totalAmount;
            private String weightUM;
            private String volumeUM;
            private String inventorySts;
            private String inTransInvId;
            private String closed;
            private String created;
            private String createdBy;
            private String lastUpdated;
            private String lastUpdatedBy;
            private String discountPrice;
            private String newstate;
            private String newstate3;
            private String newstate4;
            //表头对象
            private StockinH returnGoodSearchHeaderDto;
        }
    }
}
